ProjOpenCoastS/urls.py
from django.conf.urls import url, include
from django.contrib import admin


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^auth/', include('django_auth_oidc.urls')),
    url(r'^i18n/', include('django.conf.urls.i18n')),
    url(r'^', include('front.urls')),
    url(r'^wizard/', include('wizard.urls')),
    url(r'^viewer/', include('viewer.urls')),

    url(r'^raster/', include('raster.urls')),
    url(r'^satellite/', include('satellite.urls')),
]

handler400 = 'front.views.handler400'
handler403 = 'front.views.handler403'
handler404 = 'front.views.handler404'
handler500 = 'front.views.handler500'

front/urls.py
from django.conf.urls import url
from .views import *
from django.views.generic import TemplateView

# TODO: when there is more than one app: point to views inside 'front' redirecting to the app selected by the user
from wizard.views import deployments, new_deploy, view_deploy, open_deploy, clone_deploy, deactivate_deploy, \
    reactivate_deploy, delete_deploy, extend_deploy, view_extend_deploys, get_file, get_definition, print_deploy, \
    get_deploys, get_boundaries


urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^home/$', home, name='home'),
    url(r'^login/$', Login.as_view(), name='login'),
    url(r'^logout/$', logout_user, name='logout'),
    url(r'^register/$', register, name='register'),
    url(r'^register/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', register_confirm, name='register_confirm'),
    url(r'^profile/$', profile, name='profile'),
    url(r'^disclaimer/$', disclaimer, name='disclaimer'),

    url(r'^ratings/$', rate_service, name='rate_service'),

    url(r'^password/change/$', password_change, name='password_change'),
    url(r'^password/recover/$', password_recover, name='password_recover'),
    url(r'^password/recover/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', password_recover_confirm, name='password_recover_confirm'),

    url(r'^userprofile/activate/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', userprofile_activate, name='userprofile_activate'),
    url(r'^activate_user/(?P<username>[\w.%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4})/$', activate_user, name='activate_user'),

    url(r'^login_egi/$', login_egi, name='login_egi'),
    url(r'^login_egi/complete/$', login_egi_complete, name='login_egi_complete'),
    url(r'^logout_egi/$', logout_egi, name='logout_egi'),

    url(r'^deployments/$', deployments, name='deployments'),
    url(r'^deployments/new/$', new_deploy, name='new_deploy'),
    url(r'^deployments/view/(?P<deploy_id>[0-9]+)/$', view_deploy, name='view_deploy'),
    url(r'^deployments/open/(?P<deploy_id>[0-9]+)/$', open_deploy, name='open_deploy'),
    url(r'^deployments/clone/(?P<deploy_id>[0-9]+)/$', clone_deploy, name='clone_deploy'),
    url(r'^deployments/deactivate/(?P<deploy_id>[0-9]+)/$', deactivate_deploy, name='deactivate_deploy'),
    url(r'^deployments/reactivate/(?P<deploy_id>[0-9]+)/$', reactivate_deploy, name='reactivate_deploy'),
    url(r'^deployments/delete/(?P<deploy_id>[0-9]+)/$', delete_deploy, name='delete_deploy'),
    url(r'^deployments/extend/$', extend_deploy, name='extend_deploy'),
    url(r'^deployments/view_extends/$', view_extend_deploys, name='view_extend_deploys'),
    url(r'^deployments/get_deploys/$', get_deploys, name='get_deploys'),
    url(r'^deployments/get_definition/(?P<name>[[\w\-]+)/$', get_definition, name='get_definition'),
    url(r'^deployments/get_definition/(?P<name>[[\w\-]+)/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)$', get_definition, name='get_definition'),

    url(r'^deployments/file/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)/(?P<name>[[\w\-]+)/(?P<format>[[\w\-]+)/$', get_file, name='get_file'),
    url(r'^deployments/print/(?P<deploy_id>[0-9]+)/$', print_deploy, name='print_deploy'),
    url(r'^print/$', TemplateView.as_view(template_name="front/modal/printdeploy.html"), name='print'),

    url(r'^deployments/get_boundaries/(?P<deploy_id>[0-9]+)/$', get_boundaries, name='get_boundaries'),

    url(r'^download_file/(?P<file_cat>[[\w\-]+)/(?P<file_id>[0-9]+)/$', download_file, name='download_file'),

    url(r'^run_stats/monthly_time/(?P<year>\d{4})/(?P<month>\d{2})$', monthly_run_time),
]

front/views.py
# -*- coding: utf-8 -*-
import requests

from django.shortcuts import render, redirect, HttpResponseRedirect, HttpResponse
from django.utils.html import escape
from django.utils.translation import ugettext_lazy as _

from django.utils.http import urlsafe_base64_encode, urlsafe_base64_decode
from django.utils.encoding import force_bytes
from django.urls import reverse
from django.contrib.auth.hashers import make_password
from django.contrib.auth.tokens import default_token_generator

from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.decorators import login_required
from django.views.generic import View
from django.contrib.auth.forms import AdminPasswordChangeForm, PasswordChangeForm
from django.contrib.auth import update_session_auth_hash

from django.http import JsonResponse

from .utils import *
from .forms import *
from .models import UserProfile, UserProfileRating, SessionFile
from datamodel.models import DeploymentFile

app_name = 'front'


# View for Errors
def handler400(request, exception, template_name="front/error.html"):
    response = render(request, 'front/error.html', {'error': _('Pedido inválido.')})
    response.status_code = 400
    return response


def handler403(request, exception, template_name="front/error.html"):
    response = render(request, 'front/error.html', {'error': _('Permissões insuficientes.')})
    response.status_code = 403
    return response


def handler404(request, exception, template_name="front/error.html"):
    response = render(request, 'front/error.html', {'error': _('Página não encontrada.')})
    response.status_code = 404
    return response


def handler500(request):
    response = render(request, 'front/error.html', {'error': _('Erro de servidor.')})
    response.status_code = 500
    return response


# View for index
def home(request):
    return render(request, 'front/home.html', {'user': request.user, 'default_email': settings.DEFAULT_FROM_EMAIL})


# Class for login
class Login(View):
    form_class = AuthenticationForm
    template_name = 'front/login.html'

    def get(self, request):
        if request.user.is_authenticated:
            # If first session ever open in step1
            if not request.user.profile.read_disclaimer:
                return redirect('/wizard/step1')
            else:
                # If neither open deployments management page
                return redirect('/deployments')
        else:
            form = self.form_class(None)
            return render(request, self.template_name, {'form': form})

    def post(self, request):
        username = escape(request.POST['username'])
        password = escape(request.POST['password'])

        user = authenticate(username=username, password=password)
        if user is not None:
            if user.is_active:
                login(request, user)

                if 'next' in request.GET:
                    gonext = request.GET['next']
                    return HttpResponseRedirect(gonext)
                else:
                    # If first session ever open in step1
                    if not request.user.profile.read_disclaimer:
                        return redirect('/wizard/step1')
                    else:
                        # If neither open deployments management page
                        return redirect('/deployments')

            else:
                response = _('A sua conta encontra-se desativada!')
                return render(request, self.template_name, {'response': response})
        else:
            response = _('Entrada em sessão inválida!')
            return render(request, self.template_name, {'response': response})


# View for register
def register(request):
    response = None

    if request.method == 'POST':
        user_form = RegistrationForm(request.POST)
        profile_form = ProfileForm(request.POST)

        if user_form.is_valid() and profile_form.is_valid():
            # Save new User -> username = email
            new_user = user_form.save(commit=False)
            new_user.email = new_user.username
            new_user.save()

            if new_user:
                # Save profile info to new User
                new_profile = profile_form.save(commit=False)
                new_profile.user = new_user
                new_profile.save()
                profile_form.save_m2m()

                # Send email notifying user's register
                token = default_token_generator.make_token(new_user)
                uidb64 = urlsafe_base64_encode(force_bytes(new_user.pk))
                confirmation_link = request.build_absolute_uri(reverse('front:register_confirm', kwargs={'uidb64': uidb64, 'token': token}))

                notify_registration(new_user, new_profile, confirmation_link)

                response = _('Por favor verifique a sua conta de email (incluindo SPAM). Receberá um email para confirmar o seu registo. '
                             'Assim que o seu registo for confirmado e validado com sucesso receberá um email da ativação da conta.')

                profile_form = None
                user_form = None
            else:
                response = _('Ocorreu um erro! Por favor tente mais tarde.')
    else:
        if request.user.is_authenticated:
            return redirect('/home', {'user': request.user})
        else:
            user_form = RegistrationForm(None)
            profile_form = ProfileForm(None)

    return render(request, 'front/register.html', {'profile_form': profile_form, 'user_form': user_form, 'response': response})


# View for user register confirmation
def register_confirm(request, uidb64, token):
    try:
        # User confirming registration via OPENCoastS - if valid send notification to LNEC
        new_user = User.objects.get(pk=urlsafe_base64_decode(uidb64))
        token_valid = default_token_generator.check_token(new_user, token)

        if token_valid:
            # Already active? no need for confirmation, go to login
            if new_user.is_active:
                return redirect('/login')
            else:
                new_profile = UserProfile.objects.get(user=new_user)

                if new_profile.confirm_registration:
                    response = _('Ocorreu um erro! Este URL não é válido ou já expirou.')
                else:
                    # Mark registration confirmation in DB
                    new_profile.confirm_registration = True
                    new_profile.save()
                    response = _('Registo confirmado! Assim que o seu registo for validado com sucesso receberá um email da ativação da conta.')

                    # Send user activation link to DEFAULT_FROM_EMAIL
                    activation_link = request.build_absolute_uri(reverse('front:userprofile_activate', kwargs={'uidb64': uidb64, 'token': token}))
                    notify_confirm_registration(new_user, new_profile, activation_link)
        else:
            response = _('Ocorreu um erro! Este URL não é válido ou já expirou.')

    except Exception:
        logger.exception('Error on register confirm')
        response = _('Ocorreu um erro! Por favor tente mais tarde.')

    return render(request, 'front/register.html', {'response': response})


# View for Profile
@login_required(login_url='/login/')
def profile(request):
    response = None

    if request.method == 'POST':
        user_form = UserForm(request.POST, instance=request.user)
        profile_form = FullProfileForm(request.POST, instance=request.user.profile)
        if user_form.is_valid() and profile_form.is_valid():
            try:
                user_form.save()
                profile_form.save()
                response = _('O seu perfil foi atualizado com sucesso!')
            except:
                response = _('Ocorreu um erro! Por favor tente mais tarde.')
        else:
            response = _('Ocorreu um erro! Por favor tente mais tarde.')
    else:
        if not request.user.is_authenticated:
            return redirect('/home', {'user': request.user})
        else:
            user_form = UserForm(instance=request.user)
            profile_form = FullProfileForm(instance=request.user.profile)

    # Distinguish between normal users from EGI users (these cannot change passwords)
    disable_password = False
    if request.user.password == '***':
        disable_password = True

    return render(request, 'front/profile.html', {'user_form': user_form, 'profile_form': profile_form, 'response': response, 'disable_password': disable_password})


# View for Password update
@login_required(login_url='/login/')
def password_change(request):
    response = None

    if request.user.has_usable_password():
        pwd_form = PasswordChangeForm
    else:
        pwd_form = AdminPasswordChangeForm

    if request.method == 'POST':
        form = pwd_form(request.user, request.POST)
        if form.is_valid():
            try:
                form.save()
                update_session_auth_hash(request, form.user)
                response = _('A sua palavra-passe foi alterada com sucesso!')
            except:
                response = _('Ocorreu um erro! Por favor tente mais tarde.')
        else:
            response = _('Ocorreu um erro! Por favor tente mais tarde.')
    else:
        form = pwd_form(request.user)

    return render(request, 'front/password.html', {'pwd_form': form, 'response': response})


# View for Password recover - open reset pwd form
def password_recover_confirm(request, uidb64, token):
    token_valid = False
    response = None
    form = None

    try:
        user = User.objects.get(pk=urlsafe_base64_decode(uidb64))
        token_valid = default_token_generator.check_token(user, token)

        if token_valid:
            pwd_form = AdminPasswordChangeForm

            if request.method == 'POST':
                form = pwd_form(request.user, request.POST)
                if form.is_valid():
                    try:

front/templates/front/modal/confirm.html
{% load i18n %}

{% block content %}

    <div id="divModal_confirm" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog vertical-align-center">
          <!-- Modal content-->
          <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">{% trans "Fechar" %}</span></button>
              <span id="cfm_tit" class="modal-title">{% trans "Atenção" %}</span>
            </div>

            <div class="modal-body">
              <p id="cfm_str"></p>
              <p>
                {% trans "Deseja continuar com esta ação?" %}
              </p>
            </div>

            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Não" %}</button>
              <button id="exec_btn" class="btn btn-primary">{% trans "Sim" %}</button>
            </div>
          </div>
        </div>
      </div>
    </div>

{% endblock content %}

front/templates/front/modal/disclaimer_accept.html
{% load i18n %}

{% block content %}

    <div id="divModal_disclaimer_accept" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog vertical-align-center bigmodal">
          <!-- Modal content-->
          <div class="modal-content">

            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal"></button>
              <span class="modal-title">{% trans "Avisos Legais" %}</span>
            </div>

            <div class="modal-body">
              {% include "front/disclaimer_text.html" %}
            </div>

            <div class="modal-footer">
              <button id="btn_disclaimer" type="button" class="btn btn-primary" data-dismiss="modal">{% trans "Aceitar" %}</button>
            </div>
          </div>
        </div>
      </div>
    </div>

{% endblock content %}

front/templates/front/modal/disclaimer_read.html
{% load i18n %}

{% block content %}

    <div id="disclaimer_read" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog vertical-align-center bigmodal">
          <!-- Modal content-->
          <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">{% trans "Fechar" %}</span></button>
              <span class="modal-title">{% trans "Avisos Legais" %}</span>
            </div>

            <div class="modal-body">
              {% include "front/disclaimer_text.html" %}
            </div>

            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Fechar" %}</button>
            </div>
          </div>
        </div>
      </div>
    </div>

{% endblock content %}

front/templates/front/modal/extenddeploy.html
{% load i18n %}

{% block content %}

  <div id="divModal_extend" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
    <div class="vertical-alignment-helper">
      <div class="modal-dialog vertical-align-center">
        <!-- Modal content-->
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">{% trans "Fechar" %}</span></button>
            <span class="modal-title">{% trans "Pedido de Extensão do Sistema" %} ID:<span id="deploy_label"></span></span>
          </div>
          <div class="modal-body">

            <form id="extend_form" class="form" method="post" style="margin-top: -10px;">{% csrf_token %}
              {% include "front/form.html" %}
              <h5 id="extend_form_error" class="text-warning"></h5>

              <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Fechar" %}</button>
                <button id="btn_send" class="btn btn-primary">{% trans "Enviar" %}</button>
              </div>
            </form>

          </div>
        </div>
      </div>
    </div>
  </div>

  <script type="text/javascript">
    // Send request to extend deploy period button
    $('#btn_send').click(function(e){
        // Validate form
        var to_date = $("input[name='to_date']").val();
        var motive = $("textarea[name='motive']").val();

        if (!motive || !to_date) {
            $('#extend_form_error').html('{% trans "Todos os campos são obrigatórios." %}');
        } else {
            // First disable button to prevent multiple calls
            $(this).attr('disabled', '');
            // Add some animation
            var btn = $(this);
            var btnlbl = btn.html().replace('<span class="glyphicon glyphicon-repeat spin"></span> ', '');
            btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

            // Send email via server-side
            $.ajax({
                type: 'POST',
                url: '{% url 'front:extend_deploy' %}',
                data: $('#extend_form').serialize(),
                success: function(data) {
                    $('#divModal_extend').modal('hide');

                    if (data['msg']) {
                        $('#msg_str').html(data['msg']);
                        $('#divModal_msg').modal('show');
                    }

                    // Reset button
                    btn.removeAttr('disabled');
                    btn.html(btnlbl);
                },
                error: function(e, x, r) {
                    console.log(r + ' - ' + e);
                    $("#extend_form_error").html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');

                    // Reset button
                    btn.removeAttr('disabled');
                    btn.html(btnlbl);
                }
            });
        }
        e.preventDefault();
    });
  </script>

{% endblock content %}

front/templates/front/modal/extenddeploytable.html
{% load i18n %}

{% block content %}

    <div id="divModal_extenddeploy" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog vertical-align-center bigmodal">
          <!-- Modal content-->
          <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">{% trans "Fechar" %}</span></button>
                <span class="modal-title">{% trans "Pedidos de Extensão" %}</span>
            </div>
            <div class="modal-body">

              <div id="extenddeploy_table">
              </div>

            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Fechar" %}</button>
            </div>
          </div>
        </div>
      </div>
    </div>

{% endblock content %}

front/templates/front/modal/message.html
{% load i18n %}

{% block content %}

    <div id="divModal_msg" class="modal fade" role="dialog" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog vertical-align-center">
          <!-- Modal content-->
          <div class="modal-content">

            <div class="modal-body">
              <span id="msg_str" class="modal-title">{% if msg_str %}{{ msg_str }}{% endif %}</span>
            </div>

            <div class="modal-footer">
              <button type="button" class="btn btn-default fechar" data-dismiss="modal">{% trans "Fechar" %}</button>
            </div>
          </div>
        </div>
      </div>
    </div>

{% endblock content %}

front/templates/front/modal/processing.html
{% load static %}
{% load i18n %}

{% block content %}

    <div id="divModal_processing" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog vertical-align-center">
          <!-- Modal content-->
          <div class="modal-content">

            <div class="modal-body text-center">
              <img src="{% static 'front/img/245.gif' %}" style="margin-top: 10px;" alt="processing" />
              <p class="text-large" style="padding-top: 5px;">{% trans "a processar.. aguarde por favor.." %}.</p>
            </div>

          </div>
        </div>
      </div>
    </div>

{% endblock content %}

front/templates/front/modal/rate_service.html
{% load i18n %}

{% block content %}

  {% if rate %}
  <div id="divModal_rate" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
    <div class="vertical-alignment-helper">
      <div class="modal-dialog vertical-align-center">
        <!-- Modal content-->
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">{% trans "Fechar" %}</span></button>
            <span id="cfm_tit" class="modal-title">{% trans "Avalie este serviço" %}</span>
          </div>
          <div class="modal-body">
  {% endif %}

            <form id="rate_form" class="form" method="post">{% csrf_token %}
              {% for field in forms.1 %}
              {% if 'value' in field.auto_id %}
              <div class="rating">
                <p>...</p>
                {% for radio in field %}
                  <label>
                    {{ radio.tag }}
                    <span>{{ radio.choice_label }}</span>
                  </label>
                {% endfor %}
              </div>
              {% else %}
              <br/>
              {{ field.label_tag }} {{ field }}
              {% endif %}
              {% endfor %}
              <div class="modal-footer">
                <div class="row">
                  <div class="col-md-8">
                    <h5 class="text-warning">{% if msg %}{{ msg }}{% endif %}</h5>
                  </div>
                  <div class="col-md-4">
  {% if rate %}
                    <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Agora não" %}</button>
                    <button id="btn_rate_modal" class="btn btn-primary">{% trans "Avaliar" %}</button>
  {% else %}
                    <input type="hidden" name="ratings" value="">
                    <button type="submit" class="btn btn-primary">{% trans "Avaliar" %}</button>
  {% endif %}
                  </div>
                </div>
              </div>
            </form>

  {% if rate %}
          </div>
        </div>
      </div>
    </div>
  </div>
  {% endif %}

  <script type="text/javascript">
    $('.rating label').on("mouseover", function() {
      $(this).prevAll().addClass('hover');
      $(this).addClass('hover');

      $('.rating p').html($(this).find('span').text());
    });

    $('.rating label').on("mouseout", function() {
      $(this).prevAll().removeClass('hover');
      $(this).removeClass('hover');

      var chk = $('input[name="value"]:checked');
      if (typeof chk.val() == "undefined") {
        $('.rating p').html('...');
      } else {
        $('.rating p').html(chk.parent().find('span').text());
      }
    });

    $('.rating label').on("click", function() {
      // remove all if any exist
      $('.rating label').removeClass('active');
      $('.rating label').removeClass('invalid');

      $(this).prevAll().addClass('active');
      $(this).addClass('active');
      $('input[name="value"]').val($(this).find('input').val());
    });

    // Rate OPENCoastS action
    $('[type="submit"]').click(function(e){
      // Validate form
      var rate = $('input[name="value"]:checked').val();
      if (!rate) {
        $('.rating label').addClass('invalid');
        return false;
      }
    });

    // Rate OPENCoastS action
    $('#btn_rate_modal').click(function(e){
      // Validate form
      var rate = $('input[name="value"]:checked').val();
      if (!rate) {
        $('.rating label').addClass('invalid');
      } else {
        $.ajax({
            type: 'POST',
            url: '{% url 'front:rate_service' %}',
            data: $('#rate_form').serialize(),
            success: function(data) {
                $('#divModal_rate').modal('hide');
                $('#msg_str').html(data["msg"]);
                $('#divModal_msg').modal('show');
            },
            error: function(e, x, r) {
                console.log(r + ' - ' + e);
                $('#divModal_rate').modal('hide');
                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });
      }
      e.preventDefault();
    });
  </script>

{% endblock content %}